"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateBinanceDefaultClient = exports.binancePrivateApiRequest = exports.createBinancePrivateApiClient = void 0;
var base_axios_config_1 = require("../../base_axios_config");
var debug_helper_1 = require("../../util/debug_helper");
var axios_1 = require("axios");
var binance_axios_config_1 = require("./binance_axios_config");
var message_signature_1 = require("./message_signature");
var debug = debug_helper_1.default(__filename).debug;
exports.createBinancePrivateApiClient = function (apikey, apiSecret) {
    if (apikey === void 0) { apikey = process.env.BINANCE_API_KEY || ''; }
    if (apiSecret === void 0) { apiSecret = process.env.BINANCE_API_SECRET || ''; }
    var privateApiClient = axios_1.default.create(binance_axios_config_1.binanceAxiosConfig);
    privateApiClient.defaults.headers['X-MBX-APIKEY'] = apikey;
    privateApiClient.interceptors.request.use(function (config) {
        var timestamp = new Date().getTime();
        // Sign payload if any
        if (config.data) {
            config.data = __assign(__assign({}, config.data), { timestamp: timestamp });
            var dataSignature = message_signature_1.getBinanceMessageSignature(config.data, apiSecret);
            config.data = __assign(__assign({}, config.data), { signature: dataSignature });
        }
        config.params = __assign(__assign({}, config.params), { timestamp: timestamp });
        var paramsSignature = message_signature_1.getBinanceMessageSignature(config.params, apiSecret);
        config.params = __assign(__assign({}, config.params), { signature: paramsSignature });
        return base_axios_config_1.baseAxiosRequestInterceptor(config);
    }, base_axios_config_1.baseAxiosRequestErrorInterceptor);
    privateApiClient.interceptors.response.use(base_axios_config_1.baseAxiosResponseInterceptor, base_axios_config_1.baseAxiosResponseErrorInterceptor);
    return privateApiClient;
};
var defaultClient = exports.createBinancePrivateApiClient();
exports.binancePrivateApiRequest = function (_a) {
    var url = _a.url, method = _a.method, data = _a.data, params = _a.params;
    return __awaiter(void 0, void 0, void 0, function () {
        var binanceresponse;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, defaultClient.request({ url: url, method: method, params: params, data: data })];
                case 1:
                    binanceresponse = (_b.sent()).data;
                    debug({ binanceresponse: binanceresponse });
                    return [2 /*return*/, binanceresponse];
            }
        });
    });
};
exports.updateBinanceDefaultClient = function (apikey, apiSecret) {
    defaultClient = exports.createBinancePrivateApiClient(apikey, apiSecret);
};
