"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBinanceTickerStream = void 0;
var operators_1 = require("rxjs/operators");
var public_ws_handler_1 = require("../../api_clients/binance/public_ws_handler");
var getBinanceTickerStream = function (pair) {
    var streamName = pair.toLowerCase() + "@miniTicker";
    return public_ws_handler_1.getBinancePublicObservableFromWS([streamName]).pipe(operators_1.map(function (_a) {
        var _b = _a.data, _c = _b === void 0 ? {} : _b, _d = _c.c, lastBinancePrice = _d === void 0 ? '' : _d, _e = _c.E, utcTimestamp = _e === void 0 ? 0 : _e;
        return ({
            exchange: 'binance',
            utcTimestamp: utcTimestamp,
            pair: pair.toUpperCase(),
            price: Number(lastBinancePrice).toFixed(2),
        });
    }));
};
exports.getBinanceTickerStream = getBinanceTickerStream;
